Index: NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_skin_coare3p6.F90
===================================================================
--- NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_skin_coare3p6.F90	(revision 11615)
+++ NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_skin_coare3p6.F90	(revision 11615)
@@ -0,0 +1,322 @@
+MODULE sbcblk_skin_coare3p6
+   !!======================================================================
+   !!                   ***  MODULE  sbcblk_skin_coare3p6  ***
+   !! Computes:
+   !!   * the surface skin temperature (aka SSST) based on the cool-skin/warm-layer
+   !!     scheme used at ECMWF
+   !!    Using formulation/param. of COARE 3.6 (Fairall et al., 2019)
+   !!
+   !!   From routine turb_ecmwf maintained and developed in AeroBulk
+   !!            (https://github.com/brodeau/aerobulk)
+   !!
+   !! ** Author: L. Brodeau, September 2019 / AeroBulk (https://github.com/brodeau/aerobulk)
+   !!----------------------------------------------------------------------
+   !! History :  4.0  !  2016-02  (L.Brodeau)   Original code
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!  cswl_ecmwf : computes the surface skin temperature (aka SSST)
+   !!               based on the cool-skin/warm-layer scheme used at ECMWF
+   !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers
+   USE dom_oce         ! ocean space and time domain
+   USE phycst          ! physical constants
+   USE sbc_oce         ! Surface boundary condition: ocean fields
+
+   USE sbcblk_phy      !LOLO: all thermodynamics functions, rho_air, q_sat, etc...
+
+   USE lib_mpp         ! distribued memory computing library
+   USE in_out_manager  ! I/O manager
+   USE lib_fortran     ! to use key_nosignedzero
+
+   USE io_ezcdf ! LOLO!
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC :: CS_COARE3P6, WL_COARE3P6
+
+   !! Cool-skin related parameters:
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: delta_vl  !: thickness of the surface viscous layer (in the water) right below the air-sea interface [m]
+
+   !! Warm-layer related parameters:
+   REAL(wp), PARAMETER, PUBLIC :: H_wl_max = 20._wp    !: maximum depth of warm layer (adjustable)
+   !
+   REAL(wp), PARAMETER :: rich   = 0.65_wp   !: critical Richardson number
+   !
+   REAL(wp), PARAMETER :: Qabs_thr = 50._wp  !: threshold for heat flux absorbed in WL
+   REAL(wp), PARAMETER :: zfr0   = 0.5_wp    !: initial value of solar flux absorption
+   !
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: Tau_ac  ! time integral / accumulated momentum Tauxdt => [N.s/m^2] (reset to zero every midnight)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: Qnt_ac    ! time integral / accumulated heat stored by the warm layer Qxdt => [J/m^2] (reset to zero every midnight)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: H_wl     ! depth of warm-layer [m]
+   !!----------------------------------------------------------------------
+CONTAINS
+
+
+   SUBROUTINE CS_COARE3P6( pQsw, pQnsol, pustar, pSST, pQlat,  pdT )
+      !!---------------------------------------------------------------------
+      !!
+      !!  Cool-Skin scheme according to Fairall et al. 1996, revisited for COARE 3.6 (Fairall et al., 2019)
+      !!     ------------------------------------------------------------------
+      !!
+      !!  **   INPUT:
+      !!     *pQsw*       surface net solar radiation into the ocean     [W/m^2] => >= 0 !
+      !!     *pQnsol*     surface net non-solar heat flux into the ocean [W/m^2] => normally < 0 !
+      !!     *pustar*     friction velocity u*                           [m/s]
+      !!     *pSST*       bulk SST (taken at depth gdept_1d(1))          [K]
+      !!     *pQlat*      surface latent heat flux                       [K]
+      !!
+      !!  **  INPUT/OUTPUT:
+      !!     *pdT*  : as input =>  previous estimate of dT cool-skin
+      !!              as output =>  new estimate of dT cool-skin
+      !!
+      !!------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)    :: pQsw   ! net solar a.k.a shortwave radiation into the ocean (after albedo) [W/m^2]
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)    :: pQnsol ! non-solar heat flux to the ocean [W/m^2]
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)    :: pustar  ! friction velocity, temperature and humidity (u*,t*,q*)
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)    :: pSST ! bulk SST [K]
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)    :: pQlat  ! latent heat flux [W/m^2]
+      !!
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) :: pdT    ! dT due to cool-skin effect
+      !!---------------------------------------------------------------------
+      INTEGER  ::   ji, jj     ! dummy loop indices
+      REAL(wp) :: zQnet, zQnsol, zlamb, zdelta, zalpha_w, zfr, &
+         &        zz1, zz2, zus, &
+         &        ztf
+      !!---------------------------------------------------------------------
+
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+
+            zalpha_w = alpha_sw( pSST(ji,jj) ) ! thermal expansion coefficient of sea-water (SST accurate enough!)
+
+            zQnsol = MAX( 1._wp , - pQnsol(ji,jj) ) ! Non-solar heat loss to the atmosphere
+
+            zdelta = delta_vl(ji,jj)   ! using last value of delta
+
+            !! Fraction of the shortwave flux absorbed by the cool-skin sublayer:
+            zfr   = MAX( 0.137_wp + 11._wp*zdelta - 6.6E-5_wp/zdelta*(1._wp - EXP(-zdelta/8.E-4_wp)) , 0.01_wp ) ! Eq.16 (Fairall al. 1996b) /  !LB: why 0.065 and not 0.137 like in the paper??? Beljaars & Zeng use 0.065, not 0.137 !
+
+            zQnet = MAX( 1._wp , zQnsol - zfr*pQsw(ji,jj) )  ! Total cooling at the interface
+
+            ztf = 0.5 + SIGN(0.5_wp, zQnet) ! Qt > 0 => cooling of the layer => ztf = 1
+            !                                 Qt < 0 => warming of the layer => ztf = 0
+
+            !! Term alpha*Qb (Qb is the virtual surface cooling inc. buoyancy effect of salinity due to evap):
+            zz1 = zalpha_w*zQnet - 0.026*MIN(pQlat(ji,jj),0._wp)*rCp0_w/rLevap  ! alpha*(Eq.8) == alpha*Qb "-" because Qlat < 0
+            !! LB: this terms only makes sense if > 0 i.e. in the cooling case
+            !! so similar to what's done in ECMWF:
+            zz1 = MAX(0._wp , zz1)    ! 1. instead of 0.1 though ZQ = MAX(1.0,-pQlw(ji,jj) - pQsen(ji,jj) - pQlat(ji,jj))
+
+            zus = MAX(pustar(ji,jj), 1.E-4_wp) ! Laurent: too low wind (u*) might cause problem in stable cases:
+            zz2 = zus*zus * roadrw
+            zz2 = zz2*zz2
+            zlamb =  6._wp*( 1._wp + (rcst_cs*zz1/zz2)**0.75 )**(-1./3.) ! Lambda (Eq.14) (Saunders)
+
+            ! Updating molecular sublayer thickness (delta):
+            zz2    = rnu0_w/(SQRT(roadrw)*zus)
+            zdelta =      ztf    *          zlamb*zz2   &  ! Eq.12 (when alpha*Qb>0 / cooling of layer)
+               &    + (1._wp - ztf) * MIN(0.007_wp , 6._wp*zz2 )    ! Eq.12 (when alpha*Qb<0 / warming of layer)
+            !LB: changed 0.01 to 0.007
+
+            !! Once again with the new zdelta:
+            zfr   = MAX( 0.137_wp + 11._wp*zdelta - 6.6E-5_wp/zdelta*(1._wp - EXP(-zdelta/8.E-4_wp)) , 0.01_wp ) ! Solar absorption / Eq.16 (Fairall al. 1996b)
+            zQnet = MAX( 1._wp , zQnsol - zfr*pQsw(ji,jj) ) ! Total cooling at the interface
+
+            !! Update!
+            pdT(ji,jj) =  MIN( - zQnet*zdelta/rk0_w , 0._wp )   ! temperature increment
+            delta_vl(ji,jj) = zdelta
+
+         END DO
+      END DO
+
+   END SUBROUTINE CS_COARE3P6
+
+
+
+
+   SUBROUTINE WL_COARE3P6( kt,  pQsw, pQnsol, pTau, pSST, plon, isd, iwait,  pdT, &
+      &                    Hwl, mask_wl )
+      !!---------------------------------------------------------------------
+      !!
+      !!  Warm-Layer scheme according to COARE 3.6 (Fairall et al, 2019)
+      !!     ------------------------------------------------------------------
+      !!
+      !!  **   INPUT:
+      !!     *pQsw*       surface net solar radiation into the ocean     [W/m^2] => >= 0 !
+      !!     *pQnsol*     surface net non-solar heat flux into the ocean [W/m^2] => normally < 0 !
+      !!     *pTau*       surface wind stress                            [N/m^2]
+      !!     *pSST*       bulk SST  (taken at depth gdept_1d(1))         [K]
+      !!     *plon*       longitude                                      [deg.E]
+      !!     *isd*        current UTC time, counted in second since 00h of the current day
+      !!     *iwait*      if /= 0 then wait before updating accumulated fluxes, we are within a converging itteration loop...
+      !!
+      !!  **   OUTPUT:
+      !!     *pdT*        dT due to warming at depth of pSST such that SST_actual = pSST + pdT
+      !!---------------------------------------------------------------------
+      !!
+      !!   ** OPTIONAL OUTPUT:
+      !!     *Hwl*        depth of warm layer [m]
+      !!     *mask_wl*    mask for possible existence of a warm-layer (1) or not (0)
+      !!
+      !!------------------------------------------------------------------
+      INTEGER ,                     INTENT(in)  :: kt
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)  :: pQsw     ! surface net solar radiation into the ocean [W/m^2]     => >= 0 !
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)  :: pQnsol   ! surface net non-solar heat flux into the ocean [W/m^2] => normally < 0 !
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)  :: pTau     ! wind stress [N/m^2]
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)  :: pSST     ! bulk SST at depth gdept_1d(1) [K]
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)  :: plon     ! longitude [deg.E]
+      INTEGER ,                     INTENT(in)  :: isd      ! current UTC time, counted in second since 00h of the current day
+      INTEGER ,                     INTENT(in)  :: iwait    ! if /= 0 then wait before updating accumulated fluxes
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(out) :: pdT      ! dT due to warming at depth of pSST such that pSST_actual = pSST + pdT
+      !!
+      REAL(wp),   DIMENSION(jpi,jpj), INTENT(out), OPTIONAL :: Hwl     ! depth of warm layer [m]
+      INTEGER(1), DIMENSION(jpi,jpj), INTENT(out), OPTIONAL :: mask_wl ! mask for possible existence of a warm-layer (1) or not (0)
+      !
+      !
+      INTEGER :: ji,jj
+      !
+      REAL(wp) :: zdT_wl, zQabs, zfr, zdz
+      REAL(wp) :: zqac, ztac
+      REAL(wp) :: zalpha_w, zcd1, zcd2, flg
+      CHARACTER(len=128) :: cf_tmp
+      !!---------------------------------------------------------------------
+
+      REAL(wp) :: rlag_gw_h, &  ! local solar time lag in hours   / Greenwich meridian (lon==0) => ex: ~ -10.47 hours for Hawai
+         &        rhr_sol       ! local solar time in hours since midnight
+
+      INTEGER  :: ilag_gw_s, &  ! local solar time LAG in seconds / Greenwich meridian (lon==0) => ex: ~ INT( -10.47*3600. ) seconds for Hawai
+         &        isd_sol,   &  ! local solar time in number of seconds since local solar midnight
+         &        jl
+
+      !! INITIALIZATION:
+      pdT(:,:) = 0._wp    ! dT initially set to 0._wp
+      zdT_wl = 0._wp       ! total warming (amplitude) in warm layer
+      zQabs  = 0._wp       ! total heat absorped in warm layer
+      zfr    = zfr0        ! initial value of solar flux absorption
+      ztac   = 0._wp
+      zqac   = 0._wp
+      IF ( PRESENT(mask_wl) ) mask_wl(:,:) = 0
+
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+
+            zdz   = MAX( MIN(H_wl(ji,jj),H_wl_max) , 0.1_wp) ! depth of warm layer
+
+            !! Need to know the local solar time from longitude and isd:
+            rlag_gw_h = -1._wp * MODULO( ( 360._wp - MODULO(plon(ji,jj),360._wp) ) / 15._wp , 24._wp )
+            rlag_gw_h = -1._wp * SIGN( MIN(ABS(rlag_gw_h) , ABS(MODULO(rlag_gw_h,24._wp))), rlag_gw_h + 12._wp )
+            ilag_gw_s = INT( rlag_gw_h*3600._wp )
+            isd_sol = MODULO( isd + ilag_gw_s , 24*3600 )
+            rhr_sol = REAL( isd_sol , wp) / 3600._wp
+            !LOLO!:
+            !pdT(ji,jj) = REAL( isd_sol , wp) / 3600._wp !LOLO!
+            !END DO
+            !END DO
+            !CALL DUMP_FIELD(REAL( pdT , 4), 'isd_sol.nc', 'solar_hour' )
+            !STOP'LOLO!'
+            !DO jj = 1, jpj
+            !   DO ji = 1, jpi
+            !LOLO.
+
+            !PRINT *, ' Lag in hours / Greenwich for local solar time =', rlag_gw_h
+            !PRINT *, '     UTC     time in seconds:', isd
+            !PRINT *, ' Local solar time in seconds:', isd_sol
+            !PRINT *, '     UTC     time in hours:',   REAL(isd    ,wp)/3600._wp
+            !PRINT *, '  [WL_COARE3P6] Local solar time in hours:',   REAL(isd_sol,wp)/3600._wp
+
+            !*****  variables for warm layer  ***
+            zalpha_w = alpha_sw( pSST(ji,jj) ) ! thermal expansion coefficient of sea-water (SST accurate enough!)
+
+            zcd1 = SQRT(2._wp*rich*rCp0_w/(zalpha_w*grav*rho0_w))        !mess-o-constants 1
+            zcd2 = SQRT(2._wp*zalpha_w*grav/(rich*rho0_w))/(rCp0_w**1.5) !mess-o-constants 2
+
+            !********************************************************
+            !****  Compute apply warm layer  correction *************
+            !********************************************************
+            
+            !IF (isd_sol <= rdt ) THEN    !re-zero at midnight ! LOLO improve: risky if real midnight (00:00:00) is not a time in vtime...
+            IF ( (rhr_sol > 23.5_wp).OR.(rhr_sol < 4._wp) ) THEN
+               !PRINT *, '  [WL_COARE3P6] MIDNIGHT RESET !!!!, isd_sol =>', isd_sol
+               zdz           = H_wl_max
+               Tau_ac(ji,jj) = 0._wp
+               Qnt_ac(ji,jj) = 0._wp
+            END IF
+
+            IF ( rhr_sol > 5._wp ) THEN  ! ( 5am)
+
+               !PRINT *, '  [WL_COARE3P6] WE DO WL !'
+               !PRINT *, '  [WL_COARE3P6] isd_sol, pTau, pSST, pdT =', isd_sol, REAL(pTau(ji,jj),4), REAL(pSST(ji,jj),4), REAL(pdT(ji,jj),4)
+
+               !************************************
+               !****   set warm layer constants  ***
+               !************************************
+
+               zQabs = zfr*pQsw(ji,jj) + pQnsol(ji,jj)       ! tot heat absorbed in warm layer
+
+               !PRINT *, '  [WL_COARE3P6] rdt,  pQsw, pQnsol, zQabs =', rdt, REAL(pQsw(ji,jj),4), REAL(pQnsol(ji,jj),4), REAL(zQabs,4)
+
+               IF ( zQabs >= Qabs_thr ) THEN         ! Check for threshold
+
+                  !PRINT *, '  [WL_COARE3P6] Tau_ac, Qnt_ac =', REAL(Tau_ac(ji,jj),4), REAL(Qnt_ac(ji,jj),4)
+
+                  !Tau_ac(ji,jj) = Tau_ac(ji,jj) + MAX(.002_wp , pTau(ji,jj))*rdt      ! momentum integral
+                  ztac = Tau_ac(ji,jj) + MAX(.002_wp , pTau(ji,jj))*rdt      ! updated momentum integral
+
+                  IF ( Qnt_ac(ji,jj) + zQabs*rdt > 0._wp ) THEN         !check threshold for warm layer existence
+                     !******************************************
+                     ! Compute the absorption profile
+                     !******************************************
+                     DO jl = 1, 5                           !loop 5 times for zfr
+                        zfr = 1. - ( 0.28*0.014*(1. - EXP(-zdz/0.014)) + 0.27*0.357*(1. - EXP(-zdz/0.357)) &
+                           &        + 0.45*12.82*(1-EXP(-zdz/12.82)) ) / zdz
+                        zqac = Qnt_ac(ji,jj) + (zfr*pQsw(ji,jj) + pQnsol(ji,jj))*rdt ! updated heat absorbed
+                        IF ( zqac > 1._wp ) zdz = MAX( MIN( H_wl_max , zcd1*ztac/SQRT(zqac)) , 0.1_wp ) ! Warm-layer depth
+                     END DO
+
+                  ELSE
+                     !***********************
+                     ! Warm layer wiped out
+                     !***********************
+                     zfr  = 0.75
+                     zdz  = H_wl_max
+                     zqac = Qnt_ac(ji,jj) + (zfr*pQsw(ji,jj) + pQnsol(ji,jj))*rdt ! updated heat absorbed
+
+                  END IF !IF ( Qnt_ac(ji,jj) + zQabs*rdt > 0._wp )
+
+                  IF ( zqac > 1._wp ) zdT_wl = zcd2*zqac**1.5/ztac * MAX(zqac/ABS(zqac),0._wp)  !! => IF(zqac>0._wp): zdT_wl=zcd2*zqac**1.5/ztac ; ELSE: zdT_wl=0. / ! normally: zqac > 0 !
+                  
+                  ! Warm layer correction
+                  flg = 0.5_wp + SIGN( 0.5_wp , gdept_1d(1)-zdz )               ! => 1 when gdept_1d(1)>zdz (pdT(ji,jj) = zdT_wl) | 0 when gdept_1d(1)<zdz (pdT(ji,jj) = zdT_wl*gdept_1d(1)/zdz)
+                  pdT(ji,jj) = zdT_wl * ( flg + (1._wp-flg)*gdept_1d(1)/zdz )
+                  
+               END IF ! IF ( zQabs >= Qabs_thr )
+
+            END IF ! IF ( isd_sol >= 21600 ) THEN  ! (21600 == 6am)
+
+            IF ( iwait == 0 ) THEN
+               IF ( (zQabs >= Qabs_thr).AND.(rhr_sol >= 5._wp) ) THEN
+                  !PRINT *, '  [WL_COARE3P6] WE UPDATE ACCUMULATED FLUXES !!!'
+                  Qnt_ac(ji,jj) = zqac ! Updating Qnt_ac, heat integral
+                  Tau_ac(ji,jj) = ztac !
+                  IF ( PRESENT(mask_wl) ) mask_wl(ji,jj) = 1
+               END IF
+            END IF
+
+            H_wl(ji,jj) = zdz
+
+            IF ( PRESENT(Hwl) ) Hwl(ji,jj) = H_wl(ji,jj)
+
+         END DO
+      END DO
+
+      !WRITE(cf_tmp,'("Qnt_ac_",i5.5,".nc")') kt
+      !CALL DUMP_FIELD(REAL( Qnt_ac , 4), TRIM(cf_tmp), 'Qnt_ac')
+      
+      
+   END SUBROUTINE WL_COARE3P6
+
+
+   !!======================================================================
+END MODULE sbcblk_skin_coare3p6
Index: NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_skin_ecmwf.F90
===================================================================
--- NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_skin_ecmwf.F90	(revision 11615)
+++ NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/src/OCE/SBC/sbcblk_skin_ecmwf.F90	(revision 11615)
@@ -0,0 +1,223 @@
+MODULE sbcblk_skin_ecmwf
+   !!======================================================================
+   !!                   ***  MODULE  sbcblk_skin_ecmwf  ***
+   !! Computes:
+   !!   * the surface skin temperature (aka SSST) based on the cool-skin/warm-layer
+   !!     scheme used at ECMWF
+   !!    Using formulation/param. of IFS of ECMWF (cycle 40r1)
+   !!   based on IFS doc (avaible online on the ECMWF's website)
+   !!
+   !!   From routine turb_ecmwf maintained and developed in AeroBulk
+   !!            (https://github.com/brodeau/aerobulk)
+   !!
+   !! ** Author: L. Brodeau, September 2019 / AeroBulk (https://github.com/brodeau/aerobulk)
+   !!----------------------------------------------------------------------
+   !! History :  4.0  !  2016-02  (L.Brodeau)   Original code
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!  cswl_ecmwf : computes the surface skin temperature (aka SSST)
+   !!               based on the cool-skin/warm-layer scheme used at ECMWF
+   !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers
+   USE dom_oce         ! ocean space and time domain
+   USE phycst          ! physical constants
+   USE sbc_oce         ! Surface boundary condition: ocean fields
+
+   USE sbcblk_phy      !LOLO: all thermodynamics functions, rho_air, q_sat, etc...
+
+   USE lib_mpp         ! distribued memory computing library
+   USE in_out_manager  ! I/O manager
+   USE lib_fortran     ! to use key_nosignedzero
+
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC :: CS_ECMWF, WL_ECMWF
+
+   !! Cool-skin related parameters:
+   ! ...
+
+   !! Warm-layer related parameters:
+   REAL(wp), PARAMETER :: rd0  = 3.        !: Depth scale [m] of warm layer, "d" in Eq.11 (Zeng & Beljaars 2005)
+   REAL(wp), PARAMETER :: zRhoCp_w = rho0_w*rCp0_w
+   REAL(wp), PARAMETER :: rNu0 = 1.0       !:  be closer to COARE3p6 ???!LOLO
+   !REAL(wp), PARAMETER :: rNu0 = 0.5       !: Nu (exponent of temperature profile) Eq.11
+   !                                       !: (Zeng & Beljaars 2005) !: set to 0.5 instead of
+   !                                       !: 0.3 to respect a warming of +3 K in calm
+   !                                       !: condition for the insolation peak of +1000W/m^2
+   !!----------------------------------------------------------------------
+CONTAINS
+
+
+   SUBROUTINE CS_ECMWF( pQsw, pQnsol, pustar, pSST,  pdT )
+      !!---------------------------------------------------------------------
+      !!
+      !!  Cool-Skin scheme according to Fairall et al. 1996
+      !! Warm-Layer scheme according to Zeng & Beljaars, 2005 (GRL)
+      !!  " A prognostic scheme of sea surface skin temperature for modeling and data assimilation "
+      !!     as parameterized in IFS Cy45r1 / E.C.M.W.F.
+      !!     ------------------------------------------------------------------
+      !!
+      !!  **   INPUT:
+      !!     *pQsw*       surface net solar radiation into the ocean     [W/m^2] => >= 0 !
+      !!     *pQnsol*     surface net non-solar heat flux into the ocean [W/m^2] => normally < 0 !
+      !!     *pustar*     friction velocity u*                           [m/s]
+      !!     *pSST*       bulk SST (taken at depth gdept_1d(1))          [K]
+      !!
+      !!  **  INPUT/OUTPUT:
+      !!     *pdT*  : as input =>  previous estimate of dT cool-skin
+      !!              as output =>  new estimate of dT cool-skin
+      !!
+      !!------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)    :: pQsw   ! net solar a.k.a shortwave radiation into the ocean (after albedo) [W/m^2]
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)    :: pQnsol ! non-solar heat flux to the ocean [W/m^2]
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)    :: pustar  ! friction velocity, temperature and humidity (u*,t*,q*)
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)    :: pSST ! bulk SST [K]
+      !!
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) :: pdT    ! dT due to cool-skin effect
+      !!---------------------------------------------------------------------
+      INTEGER  ::   ji, jj     ! dummy loop indices
+      REAL(wp) :: zQnet, zQnsol, zlamb, zdelta, zalpha_w, zfr, &
+         & zusw, zusw2
+      !!---------------------------------------------------------------------
+
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+
+            zalpha_w = alpha_sw( pSST(ji,jj) ) ! thermal expansion coefficient of sea-water (SST accurate enough!)
+
+            zQnsol = MAX( 1._wp , - pQnsol(ji,jj) ) ! Non-solar heat loss to the atmosphere
+
+            zusw  = MAX(pustar(ji,jj), 1.E-4_wp)*SQRT(roadrw)    ! u* in the water
+            zusw2 = zusw*zusw
+
+            zlamb = 6._wp*( 1._wp + (zQnsol*zalpha_w*rcst_cs/(zusw2*zusw2 ))**0.75 )**(-1./3.)   ! w.r.t COARE 3p6 => seems to ommit absorbed zfr*Qsw (Qnet i.o. Qnsol) and effect of evap...
+            !                                                                                  ! so zlamb not implicit in terms of zdelta (zfr(delta)), so no need to have last guess of delta as in COARE 3.6...
+            zdelta = zlamb*rnu0_w/zusw
+
+            zfr   = MAX( 0.065_wp + 11._wp*zdelta - 6.6E-5_wp/zdelta*(1._wp - EXP(-zdelta/8.E-4_wp)) , 0.01_wp ) ! Solar absorption / Eq. 8.131 / IFS cy40r1, doc, Part IV,
+            zQnet = MAX( 1._wp , zQnsol - zfr*pQsw(ji,jj) ) ! Total cooling at the interface
+
+            !! Update!
+            pdT(ji,jj) =  MIN( - zQnet*zdelta/rk0_w , 0._wp )   ! temperature increment
+
+         END DO
+      END DO
+
+   END SUBROUTINE CS_ECMWF
+
+
+
+   SUBROUTINE WL_ECMWF( pQsw, pQnsol, pustar, pSST, pdT )
+      !!---------------------------------------------------------------------
+      !!
+      !!  Warm-Layer scheme according to Zeng & Beljaars, 2005 (GRL)
+      !!  " A prognostic scheme of sea surface skin temperature for modeling and data assimilation "
+      !!
+      !!    As included in IFS Cy45r1   /  E.C.M.W.F.
+      !!     ------------------------------------------------------------------
+      !!
+      !!  **   INPUT:
+      !!     *pQsw*       surface net solar radiation into the ocean     [W/m^2] => >= 0 !
+      !!     *pQnsol*     surface net non-solar heat flux into the ocean [W/m^2] => normally < 0 !
+      !!     *pustar*     friction velocity u*                           [m/s]
+      !!     *pSST*       bulk SST  (taken at depth gdept_1d(1))         [K]
+      !!
+      !!   **  INPUT/OUTPUT:
+      !!     *pdT*  : as input =>  previous estimate of dT warm-layer
+      !!             as output =>  new estimate of dT warm-layer
+      !!
+      !!------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)  :: pQsw     ! surface net solar radiation into the ocean [W/m^2]     => >= 0 !
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)  :: pQnsol   ! surface net non-solar heat flux into the ocean [W/m^2] => normally < 0 !
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)  :: pustar   ! friction velocity [m/s]
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in)  :: pSST     ! bulk SST at depth gdept_1d(1) [K]
+      !
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) :: pdT    ! difference between "almost surface (right below viscous layer) and depth of bulk SST
+      !
+      INTEGER :: ji,jj
+      !
+      REAL(wp) :: &
+         & zdz,    & !: thickness of the warm-layer [m]
+         & zalpha_w, & !: thermal expansion coefficient of sea-water
+         & ZSRD,   &
+         & dT_wl,   & ! temp. diff. between "almost surface (right below viscous layer) and bottom of WL
+         & zfr,zdL,zdL2, ztmp, &
+         & ZPHI, &
+         & zus_a, zusw, zusw2, &
+         & flg, zQabs, ZL1, ZL2
+      !!---------------------------------------------------------------------
+
+      IF (lwp) WRITE(numout,*) 'LOLO: WL_ECMWF@sbcblk_skin_ecmwf.F90: depth for SST bulk takent at', gdept_1d(1), ' m'
+
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+
+            zdz = rd0 ! first guess for warm-layer depth (and unique..., less advanced than COARE3p6 !)
+
+            ! dT_wl is the difference between "almost surface (right below viscous layer) and bottom of WL (here zdz)
+            ! pdT         "                          "                                    and depth of bulk SST (here gdept_1d(1))!
+            !! => but of course in general the bulk SST is taken shallower than zdz !!! So correction less pronounced!
+            !! => so here since pdT is difference between surface and gdept_1d(1), need to increase fof dT_wl !
+            flg = 0.5_wp + SIGN( 0.5_wp , gdept_1d(1)-zdz )               ! => 1 when gdept_1d(1)>zdz (pdT(ji,jj) = dT_wl) | 0 when z_s$
+            dT_wl = pdT(ji,jj) / ( flg + (1._wp-flg)*gdept_1d(1)/zdz )
+            !PRINT *, 'LOLO/mod_wl_ecmwf.f90: dT_wl2=', dT_wl
+            !PRINT *, ''
+
+            zalpha_w = alpha_sw( pSST(ji,jj) ) ! thermal expansion coefficient of sea-water (SST accurate enough!)
+
+
+            ! *** zfr = Fraction of solar radiation absorbed in warm layer (-)
+            zfr = 1._wp - 0.28_wp*EXP(-71.5_wp*zdz) - 0.27_wp*EXP(-2.8_wp*zdz) - 0.45_wp*EXP(-0.07_wp*zdz)  !: Eq. 8.157
+
+            zQabs = zfr*pQsw(ji,jj) + pQnsol(ji,jj)       ! tot heat absorbed in warm layer
+
+            zusw  = MAX(pustar(ji,jj), 1.E-4_wp)*SQRT(roadrw)    ! u* in the water
+            zusw2 = zusw*zusw
+
+
+            !! *** 1st rhs term in eq. 8.156 (IFS doc Cy45r1):
+            ZL1 = zQabs / ( zdz * zRhoCp_w * rNu0 ) * (rNu0 + 1._wp)
+
+
+            !! Buoyancy flux and stability parameter (zdl = -z/L) in water
+            ZSRD = zQabs/zRhoCp_w
+            !
+            flg = 0.5_wp + SIGN(0.5_wp, ZSRD)  ! ZSRD > 0. => 1.  / ZSRD < 0. => 0.
+            ztmp = MAX(dT_wl,0._wp)
+            zdl = (flg+1._wp) * ( zusw2 * SQRT(ztmp/(5._wp*zdz*grav*zalpha_w/rNu0)) ) & ! (dT_wl > 0.0 .AND. ZSRD < 0.0)
+               &  +    flg    *  ZSRD                                                                  !   otherwize
+            !
+            zus_a = MAX( pustar(ji,jj), 1.E-4_wp )
+            zdL = zdz*vkarmn*grav/(roadrw)**1.5_wp*zalpha_w*zdL/(zus_a*zus_a*zus_a)
+
+            !! Stability function Phi_t(-z/L) (zdL is -z/L) :
+            flg = 0.5_wp + SIGN(0.5_wp, zdL)  ! zdl > 0. => 1.  / zdl < 0. => 0.
+            zdL2 = zdL*zdL
+            ZPHI =    flg      * ( 1._wp + (5._wp*zdL + 4._wp*zdL2)/(1._wp + 3._wp*zdL + 0.25_wp*zdL2) ) &  ! (zdL > 0) Takaya et al.
+               & + (flg+1._wp) * ( 1._wp/SQRT(1._wp - 16._wp*(-ABS(zdL))) )        ! (zdl < 0) Eq. 8.136
+            !! FOR zdL > 0.0, old relations:
+            !         ZPHI = 1.+5._wp*zdL                                ! Eq. 8.136 (Large et al. 1994)
+            !         ZPHI = 1.+5.0*(zdL+zdL**2)/(1.0+3.0*zdL+zdL**2) ! SHEBA, Grachev et al. 2007
+
+            !! *** 2nd rhs term in eq. 8.156 (IFS doc Cy45r1):
+            ZL2 = - (rNu0 + 1._wp) * vkarmn * zusw / ( zdz * ZPHI )
+
+            ! Forward time / explicit solving of eq. 8.156 (IFS doc Cy45r1): (f_n+1 == pdT(ji,jj) ; f_n == dT_wl)
+            dT_wl = MAX ( dT_wl + rdt*ZL1 + rdt*ZL2*dT_wl , 0._wp )
+
+            ! dT_wl is the difference between "almost surface (right below viscous layer) and bottom of WL (here zdz)
+            !! => but of course in general the bulk SST is taken shallower than zdz !!! So correction less pronounced!
+
+            flg = 0.5_wp + SIGN( 0.5_wp , gdept_1d(1)-zdz )               ! => 1 when gdept_1d(1)>zdz (pdT(ji,jj) = dT_wl) | 0 when z_s$
+            pdT(ji,jj) = dT_wl * ( flg + (1._wp-flg)*gdept_1d(1)/zdz )
+
+         END DO
+      END DO
+
+   END SUBROUTINE WL_ECMWF
+
+   !!======================================================================
+END MODULE sbcblk_skin_ecmwf
